"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = {
    'arcane-center.xyz': {
        api_docs: 'https://arcane-center.xyz/documentation',
        api_post: 'https://arcane-center.xyz/api/:id/stats',
        api_field: 'server_count',
        api_shard_id: null,
        api_shard_count: 'shard_count',
        api_shards: null,
        api_get: null,
        api_all: null,
    },
    'bladebotlist.xyz': {
        api_docs: null,
        api_post: 'https://bladebotlist.xyz/api/bots/:id/stats',
        api_field: 'server_count',
        api_shard_id: null,
        api_shard_count: 'shard_count',
        api_shards: null,
        api_get: 'https://bladebotlist.xyz/api/bots/:id',
        api_all: null,
    },
    'blist.xyz': {
        api_docs: 'https://blist.xyz/docs/',
        api_post: 'https://blist.xyz/api/v2/bot/:id/stats',
        api_field: 'server_count',
        api_shard_id: null,
        api_shard_count: 'shard_count',
        api_shards: null,
        api_get: 'https://blist.xyz/api/v2/bot/:id',
        api_all: null,
    },
    'botlists.com': {
        api_docs: 'https://botlists.com/api/docs',
        api_post: 'https://botlists.com/api/bot',
        api_field: 'guild_count',
        api_shard_id: null,
        api_shard_count: 'shard_count',
        api_shards: null,
        api_get: 'https://botlists.com/api/bot',
        api_all: null,
    },
    'botrix.cc': {
        api_docs: 'https://docs.botrix.cc/',
        api_post: 'https://botrix.cc/api/v1/bot/:id',
        api_field: 'servers',
        api_shard_id: null,
        api_shard_count: 'shards',
        api_shards: null,
        api_get: 'https://botrix.cc/api/v1/bot/:id',
        api_all: null,
    },
    'bots.discordlabs.org': {
        api_docs: 'https://docs.discordlabs.org/',
        api_post: 'https://bots.discordlabs.org/v2/bot/:id/stats',
        api_field: 'server_count',
        api_shard_id: null,
        api_shard_count: 'shard_count',
        api_shards: null,
        api_get: 'https://bots.discordlabs.org/v2/bot/:id',
        api_all: null,
    },
    'bots.ondiscord.xyz': {
        api_docs: 'https://bots.ondiscord.xyz/info/api',
        api_post: 'https://bots.ondiscord.xyz/bot-api/bots/:id/guilds',
        api_field: 'guildCount',
        api_shard_id: null,
        api_shard_count: null,
        api_shards: null,
        api_get: null,
        api_all: null,
    },
    'botsdatabase.com': {
        api_docs: 'https://docs.botsdatabase.com/',
        api_post: 'https://api.botsdatabase.com/v1/bots/:id',
        api_field: 'servers',
        api_shard_id: null,
        api_shard_count: null,
        api_shards: 'shards',
        api_get: 'https://api.botsdatabase.com/v1/bots/:id',
        api_all: null,
    },
    'botsfordiscord.com': {
        api_docs: 'https://docs.botsfordiscord.com',
        api_post: 'https://botsfordiscord.com/api/bot/:id',
        api_field: 'server_count',
        api_shard_id: null,
        api_shard_count: null,
        api_shards: null,
        api_get: 'https://botsfordiscord.com/api/bot/:id',
        api_all: null,
    },
    'discord.boats': {
        api_docs: 'https://docs.discord.boats/',
        api_post: 'https://discord.boats/api/bot/:id',
        api_field: 'server_count',
        api_shard_id: null,
        api_shard_count: null,
        api_shards: null,
        api_get: 'https://discord.boats/api/bot/:id',
        api_all: null,
    },
    'discord.bots.gg': {
        api_docs: 'https://discord.bots.gg/docs',
        api_post: 'https://discord.bots.gg/api/v1/bots/:id/stats',
        api_field: 'guildCount',
        api_shard_id: 'shardId',
        api_shard_count: 'shardCount',
        api_shards: null,
        api_get: 'https://discord.bots.gg/api/v1/bots/:id',
        api_all: 'https://discord.bots.gg/api/v1/bots?limit=100&sort=guildcount&order=desc',
    },
    'discordbotlist.com': {
        api_docs: 'https://docs.discordbotlist.com',
        api_post: 'https://discordbotlist.com/api/bots/:id/stats',
        api_field: 'guilds',
        api_shard_id: 'shard_id',
        api_shard_count: null,
        api_shards: null,
        api_get: 'https://discordbotlist.com/api/bots/:id',
        api_all: 'https://discordbotlist.com/api/bots',
    },
    'discordbots.co': {
        api_docs: 'https://discordbots.co/api',
        api_post: 'https://api.discordbots.co/v1/public/bot/:id/stats',
        api_field: 'serverCount',
        api_shard_id: null,
        api_shard_count: 'shardCount',
        api_shards: null,
        api_get: 'https://api.discordbots.co/v1/public/bot/:id',
        api_all: null,
    },
    'discordextremelist.xyz': {
        api_docs: 'https://discordextremelist.xyz/docs#api-routes',
        api_post: 'https://api.discordextremelist.xyz/v2/bot/:id/stats',
        api_field: 'guildCount',
        api_shard_id: null,
        api_shard_count: 'shardCount',
        api_shards: null,
        api_get: 'https://api.discordextremelist.xyz/v2/bot/:id',
        api_all: null,
    },
    'discordlist.space': {
        api_docs: 'https://docs.discordlist.space/',
        api_post: 'https://api.discordlist.space/v1/bots/:id',
        api_field: 'server_count',
        api_shard_id: null,
        api_shard_count: null,
        api_shards: 'shards',
        api_get: 'https://api.discordlist.space/v1/bots/:id',
        api_all: 'https://api.discordlist.space/v1/bots',
    },
    'discordlistology.com': {
        api_docs: 'https://discordlistology.com/developer/documentation',
        api_post: 'https://discordlistology.com/api/v1/bots/:id/stats',
        api_field: 'servers',
        api_shard_id: null,
        api_shard_count: 'shards',
        api_shards: null,
        api_get: 'https://discordlistology.com/api/v1/bots/:id/stats',
        api_all: null,
    },
    'disforge.com': {
        api_docs: 'https://disforge.com/developer',
        api_post: 'https://disforge.com/api/botstats/:id',
        api_field: 'servers',
        api_shard_id: null,
        api_shard_count: null,
        api_shards: null,
        api_get: null,
        api_all: null,
    },
    'fateslist.xyz': {
        api_docs: 'https://fateslist.xyz/api/docs ',
        api_post: 'https://fateslist.xyz/api/bots/:id/stats',
        api_field: 'guild_count',
        api_shard_id: null,
        api_shard_count: 'shard_count',
        api_shards: null,
        api_get: 'https://fateslist.xyz/api/bots/:id',
        api_all: null,
    },
    'infinitybotlist.com': {
        api_docs: 'https://docs.infinitybotlist.com/',
        api_post: 'https://api.infinitybotlist.com/bot/:id',
        api_field: 'servers',
        api_shard_id: null,
        api_shard_count: 'shards',
        api_shards: null,
        api_get: 'https://api.infinitybotlist.com/bot/:id/info',
        api_all: null,
    },
    'nooder.co': {
        api_docs: 'https://nooder.co/api/docs',
        api_post: 'https://nooder.co/api/bot/:id/stats',
        api_field: 'server_count',
        api_shard_id: null,
        api_shard_count: null,
        api_shards: null,
        api_get: 'https://nooder.co/api/bot/:id',
        api_all: null,
    },
    'paradisebots.net': {
        api_docs: 'https://docs.paradisebots.net/',
        api_post: 'https://paradisebots.net/api/v1/bot/:id',
        api_field: 'server_count',
        api_shard_id: null,
        api_shard_count: 'shard_count',
        api_shards: null,
        api_get: 'https://paradisebots.net/api/v1/bots/:id',
        api_all: null,
    },
    'space-bot-list.xyz': {
        api_docs: 'https://spacebots.gitbook.io/tutorial-en/api/stats',
        api_post: 'https://space-bot-list.xyz/api/bots/:id',
        api_field: 'guilds',
        api_shard_id: null,
        api_shard_count: null,
        api_shards: null,
        api_get: 'https://space-bot-list.xyz/api/bots/:id',
        api_all: null,
    },
    'top.gg': {
        api_docs: 'https://top.gg/api/docs',
        api_post: 'https://top.gg/api/bots/:id/stats',
        api_field: 'server_count',
        api_shard_id: 'shard_id',
        api_shard_count: 'shard_count',
        api_shards: 'shards',
        api_get: 'https://top.gg/api/bots/:id',
        api_all: null,
    },
    'voidbots.net': {
        api_docs: 'https://docs.voidbots.net/',
        api_post: 'https://api.voidbots.net/bot/stats/:id',
        api_field: 'server_count',
        api_shard_id: null,
        api_shard_count: 'shard_count',
        api_shards: null,
        api_get: 'https://api.voidbots.net/bot/info/:id',
        api_all: null,
    },
    'wonderbotlist.com': {
        api_docs: 'https://api.wonderbotlist.com/en/',
        api_post: 'https://api.wonderbotlist.com/v1/bot/:id',
        api_field: 'serveurs',
        api_shard_id: null,
        api_shard_count: 'shards',
        api_shards: null,
        api_get: 'https://api.wonderbotlist.com/v1/bot/:id',
        api_all: null,
    },
    'yabl.xyz': {
        api_docs: 'https://yabl.xyz/api',
        api_post: 'https://yabl.xyz/api/bot/:id/stats',
        api_field: 'guildCount',
        api_shard_id: null,
        api_shard_count: null,
        api_shards: null,
        api_get: 'https://yabl.xyz/api/bot/:id',
        api_all: 'https://yabl.xyz/api/bots/all',
    },
    'topcord.xyz': {
        api_docs: 'https://docs.topcord.xyz/#/',
        api_post: 'https://api.topcord.xyz/bot/:id/stats',
        api_field: 'guilds',
        api_shard_id: null,
        api_shard_count: 'shards',
        api_shards: null,
        api_get: 'https://api.topcord.xyz/bot/:id',
        api_all: 'https://api.topcord.xyz/bots',
    },
};
//# sourceMappingURL=fallbackListData.js.map